<script setup lang="ts">
  import { TransitionRoot } from '@headlessui/vue';

  const { currentSlide } = usePresentation();
  const noteEl = ref();
  const isDisplayNotesMenu = ref(false);
  const currentNoteIndex = ref(1);
  const slideNotes = computed(() => currentSlide.value?.notes || []);

  const currentNoteContent = computed(
    () => slideNotes.value[currentNoteIndex.value - 1]?.translated?.config?.content?.value,
  );
  watch(slideNotes, (notes) => {
    currentNoteIndex.value = 1;
    if (!notes.length) {
      isDisplayNotesMenu.value = false;
    }
  });

  watch(currentNoteIndex, () => {
    if (noteEl.value) {
      noteEl.value.scrollTo(0, 0);
    }
  });
</script>

<template>
  <div
    class="border-(t border) bg-background-raised flex w-full flex-col items-center justify-between p-5"
  >
    <div class="flex w-full justify-between">
      <div class="flex flex-row items-center">
        <span class="font-bold">{{ $t('presentation.guideTool.notes') }}</span>
        <div v-if="isDisplayNotesMenu" class="ml-4 flex items-center space-x-2">
          <SwButton
            variant="action"
            class="!p-1"
            :disabled="currentNoteIndex === 1"
            @click="currentNoteIndex--"
          >
            <span class="i-sw-solid:chevron-left-xs" />
          </SwButton>
          <span class="text-sm/6 font-semibold">
            {{ currentNoteIndex }} {{ $t('of') }} {{ slideNotes.length }}
          </span>
          <SwButton
            variant="action"
            class="!p-1"
            :disabled="currentNoteIndex === slideNotes.length"
            @click="currentNoteIndex++"
          >
            <span class="i-sw-solid:chevron-right-xs" />
          </SwButton>
        </div>
        <span v-else class="text-information-subdued pl-1"> ({{ slideNotes.length }})</span>
      </div>
      <SwTooltip
        :content="isDisplayNotesMenu ? $t('presentation.hideNotes') : $t('presentation.showNotes')"
        position="topCenter"
        width="max-width"
      >
        <SwButton
          variant="action"
          :disabled="!slideNotes.length"
          @click="isDisplayNotesMenu = !isDisplayNotesMenu"
        >
          <span class="text-sm/none font-medium">
            {{ isDisplayNotesMenu ? $t('hide') : $t('show') }}
          </span>
          <span
            :class="[
              isDisplayNotesMenu ? 'i-sw-solid:times-circle ' : 'i-sw-solid:eye ',
              'ml-1.5 text-sm',
            ]"
          />
        </SwButton>
      </SwTooltip>
    </div>
    <TransitionRoot
      class="w-full"
      :show="isDisplayNotesMenu"
      enter="transition-all duration-500 ease-in-out"
      enter-from="h-0 opacity-0"
      enter-to="h-[17.5rem] opacity-1"
      leave="transition-all duration-500 ease-in-out"
      leave-from="h-[17.5rem] opacity-1"
      leave-to="h-0 opacity-0"
    >
      <div class="flex h-[17.5rem] w-full items-center pt-4 md:pt-5">
        <div
          ref="noteEl"
          class="max-h-full overflow-y-scroll rounded-md border border-yellow-400 bg-yellow-50 p-4 [&>*]:break-words"
          v-html="currentNoteContent"
        />
      </div>
    </TransitionRoot>
  </div>
</template>
